summaryrefslogtreecommitdiffstats
path: root/development/cosmocc
diff options
context:
space:
mode:
Diffstat (limited to 'development/cosmocc')
-rw-r--r--development/cosmocc/README39
-rw-r--r--development/cosmocc/cosmocc.SlackBuild89
-rw-r--r--development/cosmocc/cosmocc.info10
-rw-r--r--development/cosmocc/scripts/register_ape.sh5
-rw-r--r--development/cosmocc/scripts/unregister_ape.sh5
-rw-r--r--development/cosmocc/slack-desc19
-rw-r--r--development/cosmocc/wrapper.sh3
7 files changed, 170 insertions, 0 deletions
diff --git a/development/cosmocc/README b/development/cosmocc/README
new file mode 100644
index 0000000000..a8557c1f29
--- /dev/null
+++ b/development/cosmocc/README
@@ -0,0 +1,39 @@
+cosmocc is a precompiled version of GCC that produces polyglot
+executables for the x86_64 / aarch64 architecture using the
+Cosmopolitan libc.
+
+Cosmopolitan Libc makes C a build-once run-anywhere language, like Java,
+except it doesn't need an interpreter or virtual machine. Instead, it
+reconfigures stock GCC and Clang to output a POSIX-approved polyglot
+format that runs natively on many operating systems with the best
+possible performance and a tiny footprint.
+
+======= Support Vector =======
+Platform | Min Version | Circa
+==============================
+AMD | K8 Venus | 2005
+Intel | Core | 2006
+Linux | 2.6.18 | 2007
+Windows | 8 | 2012
+Mac OS X | 15.6 | 2018
+OpenBSD | 7 | 2021
+FreeBSD | 13 | 2020
+NetBSD | 9.2 | 2021
+==============================
+
+NOTES:
+* on calling APE programs:
+ upto zsh version 5.9, it's required to call APE programs
+ this way:
+ sh -c ./APE-program
+ The same case is for Python's subprocess, old versions of fish, etc.
+* on reproducible builds:
+ The cosmocc compiler is designed to generate deterministic output
+ across platforms. Please note that users who need reproducible
+ builds may also want to look into explicitly defining environment
+ variables like `LC_ALL=C` and `SOURCE_DATE_EPOCH=0`, in addition to
+ undefining macros such as `-U__DATE__` and `-U__TIME__`.
+* on (un)registering APE with binfmt_misc:
+ two simple scripts are included in case you want to register or
+ unregister the APE loader with the binfmt_misc kernel facility.
+ You may find them in the /opt/cosmocc/scripts/ directory.
diff --git a/development/cosmocc/cosmocc.SlackBuild b/development/cosmocc/cosmocc.SlackBuild
new file mode 100644
index 0000000000..b8f92c53b3
--- /dev/null
+++ b/development/cosmocc/cosmocc.SlackBuild
@@ -0,0 +1,89 @@
+#!/bin/bash
+
+# Slackware build script for cosmocc
+
+# Originally written 2024 Juan M. Lasca <email removed>
+# Modified and now maintained by B. Watson <urchlay@slackware.uk>
+
+# Licensed under the WTFPL. See http://www.wtfpl.net/txt/copying/ for details.
+
+# 20240312 bkw:
+# - update for v3.3.2.
+# - use wrapper script rather than symlinks for /usr/bin/* since the
+# symlinks didn't actually work.
+
+# 20240219 bkw: BUILD=3
+# - Take over maintenance.
+# - Relicense as WTFPL.
+# - Fix permission error in package, when $CWD files are not owned by root.
+# - Do not install upstream's licenses .xz compressed.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=cosmocc
+VERSION=${VERSION:-3.3.2}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+mkdir $PRGNAM-$VERSION
+cd $PRGNAM-$VERSION
+unzip $CWD/$PRGNAM-$VERSION.zip
+chown -R root:root .
+find -L . -perm /111 -a \! -perm 755 -a -exec chmod 755 {} + -o \
+ \! -perm /111 -a \! -perm 644 -a -exec chmod 644 {} +
+
+mkdir -p $PKG/opt/$PRGNAM/scripts $PKG/usr/bin
+install -m0755 -oroot -groot $CWD/scripts/* $PKG/opt/$PRGNAM/scripts
+
+for i in bin include x86_64-linux-cosmo aarch64-linux-cosmo libexec; do
+ mv $i $PKG/opt/$PRGNAM
+done
+
+install -oroot -groot -m0755 $CWD/wrapper.sh $PKG/opt/$PRGNAM/bin/wrapper.sh
+
+# 20240312 bkw: can't use symlinks for these, or else we get:
+# /usr/bin/cosmocc: line 327: /usr/bin/x86_64-linux-cosmo-gcc: No such file or directory
+for i in mktemper march-native zipcopy apelink cosmocross cosmoar \
+ assimilate zipobj cosmoaddr2line cosmocc mkdeps cosmoc++ \
+ cosmoinstall pecheck
+do
+ ln -s ../../opt/$PRGNAM/bin/wrapper.sh $PKG/usr/bin/$i
+done
+
+# remove empty directories:
+rmdir $PKG/opt/cosmocc/libexec/gcc/{x86_64,aarch64}-linux-cosmo/*/install-tools || true
+
+PKGDOC=$PKG/usr/doc/$PRGNAM-$VERSION
+mkdir -p $PKGDOC
+cp -a LICENSE.*gpl* README.md $PKGDOC
+cat $CWD/$PRGNAM.SlackBuild > $PKGDOC/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE
diff --git a/development/cosmocc/cosmocc.info b/development/cosmocc/cosmocc.info
new file mode 100644
index 0000000000..61866f46d4
--- /dev/null
+++ b/development/cosmocc/cosmocc.info
@@ -0,0 +1,10 @@
+PRGNAM="cosmocc"
+VERSION="3.3.2"
+HOMEPAGE="https://github.com/jart/cosmopolitan"
+DOWNLOAD="UNSUPPORTED"
+MD5SUM=""
+DOWNLOAD_x86_64="https://cosmo.zip/pub/cosmocc/cosmocc-3.3.2.zip"
+MD5SUM_x86_64="5a6be78d383795581c74a8854cd9d284"
+REQUIRES=""
+MAINTAINER="B. Watson"
+EMAIL="urchlay@slackware.uk"
diff --git a/development/cosmocc/scripts/register_ape.sh b/development/cosmocc/scripts/register_ape.sh
new file mode 100644
index 0000000000..d78f007d53
--- /dev/null
+++ b/development/cosmocc/scripts/register_ape.sh
@@ -0,0 +1,5 @@
+
+# register APE loader
+echo ':APE:M::MZqFpD::/usr/bin/ape:' > /proc/sys/fs/binfmt_misc/register
+echo ':APE-jart:M::jartsr::/usr/bin/ape:' > /proc/sys/fs/binfmt_misc/register
+
diff --git a/development/cosmocc/scripts/unregister_ape.sh b/development/cosmocc/scripts/unregister_ape.sh
new file mode 100644
index 0000000000..ab46635591
--- /dev/null
+++ b/development/cosmocc/scripts/unregister_ape.sh
@@ -0,0 +1,5 @@
+
+# unregister APE loader
+echo -1 > /proc/sys/fs/binfmt_misc/cli
+echo -1 > /proc/sys/fs/binfmt_misc/status
+
diff --git a/development/cosmocc/slack-desc b/development/cosmocc/slack-desc
new file mode 100644
index 0000000000..447ac7b47f
--- /dev/null
+++ b/development/cosmocc/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+cosmocc: cosmocc (APE compiler toolchain)
+cosmocc:
+cosmocc: cosmocc is a precompiled version of GCC that produces polyglot
+cosmocc: executables for the x86_64 architecture using the Cosmopolitan libc.
+cosmocc:
+cosmocc: For more information, see:
+cosmocc: https://github.com/jart/cosmopolitan
+cosmocc: https://cosmo.zip/
+cosmocc: https://justine.lol/ape.html
+cosmocc:
+cosmocc:
diff --git a/development/cosmocc/wrapper.sh b/development/cosmocc/wrapper.sh
new file mode 100644
index 0000000000..09cfb295d1
--- /dev/null
+++ b/development/cosmocc/wrapper.sh
@@ -0,0 +1,3 @@
+#!/bin/sh
+
+exec /opt/cosmocc/bin/$( basename $0 ) "$@"